
#define INLINE inline
//#define INLINE

//#define FIXED_DEBUG

#ifndef __FIXED_H__
#define __FIXED_H__

#include <stdlib.h>
#include <iostream>

#define _GCC_TEMPLATE_BUG_ 1


#ifdef FIXED_DEBUG
#define TEST_TOL 0.05
#define TEST(X,OP) TEST2(X,m_f,OP)
#define TEST2(X,Y,OP) { double DIFF_TEST = (((double)(X)) - (f2d(Y)));  \
if (DIFF_TEST<-TEST_TOL || DIFF_TEST>TEST_TOL) { printf("%s: %g vs %g\n", OP,((double)(X)),(f2d(Y))); } }
#define TEST3(X,Y,OP,DB) { double DIFF_TEST = (((double)(X)) - (f2d(Y)));  \
if (DIFF_TEST<-TEST_TOL || DIFF_TEST>TEST_TOL) { printf("%s: %g vs %g\n", OP,((double)(X)),(f2d(Y))); DB; } }
#define TEST4(X,Y,OP,DB) { double DIFF_TEST = (((double)(X)) - (fixed<SH>::f2d(Y)));  \
if (DIFF_TEST<-TEST_TOL || DIFF_TEST>TEST_TOL) { printf("%s: %g vs %g\n", OP,((double)(X)),(fixed<SH>::f2d(Y))); DB; } }
#else
#define TEST(X,OP)
#define TEST2(X,Y,OP)
#define TEST3(X,Y,OP,DB)
#define TEST4(X,Y,OP,DB)
#endif

template <unsigned int SH> class fixed {
public:

	INLINE fixed ( int i = 0 )      : m_f ( i2f( i ) ) { TEST(i,"i2f") }
	INLINE fixed ( signed long i )      : m_f ( i2f( i ) ) { TEST(i,"i2f") }
	INLINE fixed ( unsigned long i )      : m_f ( i2f( i ) ) { TEST(i,"i2f") }
	INLINE fixed ( double d )       : m_f ( d2f( d )) { TEST(d,"d2f") }
	INLINE fixed ( const fixed &f ) : m_f ( f. m_f ) { }
	
	INLINE operator bool ( ) const   { return m_f != 0; }	
	INLINE operator double ( ) const { return f2d( m_f ); }
	INLINE operator float ( ) const  { return (float) f2d( m_f ); }
	INLINE operator int ( ) const    { return (int) f2i( m_f ); }
	INLINE operator long ( ) const    { return (long) f2i( m_f ); }

	INLINE fixed &operator = ( const fixed &f ) { m_f = f. m_f; return *this; }
	INLINE fixed &operator = ( double d )       { m_f = d2f( d ); return *this; }
	INLINE fixed &operator = ( float f )        { m_f = d2f( f ); return *this; }
	INLINE fixed &operator = ( int i )          { m_f = i2f( i ); return *this; }

	INLINE fixed &operator += ( const fixed &f ) { m_f += f. m_f; return *this; }
	INLINE fixed &operator -= ( const fixed &f ) { m_f -= f. m_f; return *this; }
	INLINE fixed &operator *= ( const fixed &f ) { 
	  TEST3(f2d(m_f)*f2d(f.m_f),mul(m_f,f.m_f),"*=",
	    printf("%f * %f = %f\n", f2d(m_f), f2d(f.m_f), f2d(mul(m_f,f.m_f))));
	  m_f = mul ( m_f, f. m_f ); 
	  return *this; 
	}
	INLINE fixed &operator /= ( const fixed &f ) { 
	  TEST3(f2d(m_f)/f2d(f.m_f),div(m_f,f.m_f),"/=",
  	    printf("%f / %f = %f\n", f2d(m_f), f2d(f.m_f), f2d(div(m_f,f.m_f))));
	  m_f = div ( m_f, f. m_f ); return *this; 
	}

	INLINE fixed &operator += ( int i ) { m_f += i2f( i ); return *this; }
	INLINE fixed &operator -= ( int i ) { m_f -= i2f( i ); return *this; }
	INLINE fixed &operator *= ( int i ) { 
	  TEST3(f2d(m_f)*i,m_f*i,"i*=",
  	    printf("%f * %d = %f\n", f2d(m_f), i, f2d(m_f*i)));
	    m_f *= i; return *this; 
	}
	INLINE fixed &operator /= ( int i ) { 
	  TEST3(f2d(m_f)/i,m_f/i,"i/=",
  	    printf("%f / %d = %f\n", f2d(m_f), i, f2d(m_f/i)));
	  m_f /= i; return *this; 
	}

	INLINE fixed &operator += ( double d ) { m_f += d2f( d ); return *this; }
	INLINE fixed &operator -= ( double d ) { m_f -= d2f( d ); return *this; }

	INLINE fixed &operator *= ( double d ) { 
	  TEST3(f2d(m_f)*d,mul(m_f,d2f(d)),"d*=",
  	    printf("%f * %f = %f\n", f2d(m_f), d, f2d(mul(m_f,d2f(d)))));
	  m_f = mul ( m_f, d2f( d )); return *this; 
	}
	INLINE fixed &operator /= ( double d ) { 
	  TEST3(f2d(m_f)/d,div(m_f,d2f(d)),"d/=",
  	    printf("%f / %f = %f\n", f2d(m_f), d, f2d(div(m_f,d2f(d)))));
	  m_f = div ( m_f, d2f( d )); return *this; 
	}

	INLINE fixed operator - ( ) const { return fixed ( -m_f, true ); }

	INLINE fixed operator + ( const fixed &f ) const { return fixed ( m_f + f. m_f, true ); }
	INLINE fixed operator - ( const fixed &f ) const { return fixed ( m_f - f. m_f, true ); }


	INLINE fixed operator * ( const fixed &f ) const { 
	  TEST3(f2d(m_f)*f2d(f.m_f),mul(m_f,f.m_f),"*",
  	    printf("%f * %f = %f\n", f2d(m_f), f2d(f.m_f), f2d(mul(m_f,f.m_f))));
	  return fixed ( mul ( m_f, f. m_f ), true ); 
	}
	INLINE fixed operator / ( const fixed &f ) const { 
	  TEST3(f2d(m_f)/f2d(f.m_f),div(m_f,f.m_f),"/",
  	    printf("%f / %f = %f\n", f2d(m_f), f2d(f.m_f), f2d(div(m_f,f.m_f))));
	  return fixed ( div ( m_f, f. m_f ), true ); 
	}

	INLINE fixed operator + ( double d ) const { return fixed ( m_f + d2f( d ), true ); }
	INLINE fixed operator - ( double d ) const { return fixed ( m_f - d2f( d ), true ); }
	INLINE fixed operator * ( double d ) const { 
	  TEST3(f2d(m_f)*d,mul(m_f,d2f(d)),"d*",
  	    printf("%f * %f = %f\n", f2d(m_f), d, f2d(mul(m_f,d2f(d)))));
	  return fixed ( mul ( m_f, d2f( d )), true ); 
	}
	INLINE fixed operator / ( double d ) const { 
	  TEST3(f2d(m_f)/d,div(m_f,d2f(d)),"d/",
  	    printf("%f / %f = %f\n", f2d(m_f), d, f2d(div(m_f,d2f(d)))));
	  return fixed ( div ( m_f, d2f( d )), true ); 
	}

	INLINE fixed operator + ( int i ) const { return fixed ( m_f + i2f( i ), true ); }
	INLINE fixed operator - ( int i ) const { return fixed ( m_f - i2f( i ), true ); }
	INLINE fixed operator * ( int i ) const { 
	  TEST3(f2d(m_f)*i,m_f*i,"i*",
  	    printf("%f * %d = %f\n", f2d(m_f), i, f2d(m_f*i)));
	  return fixed ( m_f * i, true ); 
	}
	INLINE fixed operator * ( signed long i ) const { 
	  TEST3(f2d(m_f)*i,m_f*i,"i*",
  	    printf("%f * %d = %f\n", f2d(m_f), i, f2d(m_f*i)));
	  return fixed ( m_f * i, true ); 
	}
	INLINE fixed operator * ( unsigned long i ) const { 
	  TEST3(f2d(m_f)*i,m_f*i,"i*",
  	    printf("%f * %d = %f\n", f2d(m_f), i, f2d(m_f*i)));
	  return fixed ( m_f * i, true ); 
	}
	INLINE fixed operator / ( int i ) const { 
	  TEST3(f2d(m_f)/i,m_f/i,"i/",
  	    printf("%f / %d = %f\n", f2d(m_f), i, f2d(m_f/i)));
	  return fixed ( m_f / i, true ); 
	}

	INLINE bool operator <  ( const fixed &f ) const { return m_f < f. m_f; }
	INLINE bool operator >  ( const fixed &f ) const { return m_f > f. m_f; }
	INLINE bool operator <= ( const fixed &f ) const { return m_f <= f. m_f; }
	INLINE bool operator >= ( const fixed &f ) const { return m_f >= f. m_f; }
	INLINE bool operator == ( const fixed &f ) const { return m_f == f. m_f; }
	INLINE bool operator != ( const fixed &f ) const { return m_f != f. m_f; }

	INLINE bool operator <  ( double d ) const { return m_f < d2f( d ); }
	INLINE bool operator >  ( double d ) const { return m_f > d2f( d ); }
	INLINE bool operator <= ( double d ) const { return m_f <= d2f( d ); }
	INLINE bool operator >= ( double d ) const { return m_f >= d2f( d ); }
	INLINE bool operator == ( double d ) const { return m_f == d2f( d ); }
	INLINE bool operator != ( double d ) const { return m_f != d2f( d ); }

	INLINE bool operator <  ( int i ) const { return m_f < i2f( i ); }
	INLINE bool operator >  ( int i ) const { return m_f > i2f( i ); }
	INLINE bool operator <= ( int i ) const { return m_f <= i2f( i ); }
	INLINE bool operator >= ( int i ) const { return m_f >= i2f( i ); }
	INLINE bool operator == ( int i ) const { return m_f == i2f( i ); }
	INLINE bool operator != ( int i ) const { return m_f != i2f( i ); }

#if _GCC_TEMPLATE_BUG_
public: 
#else
private:
#endif
	typedef int fix_t;

	INLINE static double f2d ( fix_t f )   { return ((double) f ) / ((double) ( 1 << SH )); }
	INLINE static fix_t  d2f ( double d )  { return (fix_t) ( d * ((double) ( 1 << SH ))); }
	
	INLINE static int    f2i ( fix_t f )   { return (int) ( f >> SH ); }
	//	INLINE static int    f2i ( fix_t f )   { return (int) ( (f + (1<<(SH-1))) >> SH ); }

	INLINE static fix_t  i2f ( int i )     { return (fix_t) ( i << SH ); }	
	
	INLINE static fix_t mul ( fix_t m1, fix_t m2 )	{ 
	  //	  if (m1 == 0 || m2 == 0) return(0);
	  //	  if (m1 == 1<<SH) return(m2);
	  //	  if (m2 == 1<<SH) return(m1);
	  //	  if (m1 == -1<<SH) return(-m2);
	  //	  if (m2 == -1<<SH) return(-m1);
	  return (fix_t) ((((long long int) m1 ) * m2 ) >> SH ); 
	}	

	INLINE static fix_t div ( fix_t d1, fix_t d2 )	{ return (fix_t) ((((long long int) d1 ) << SH ) / d2 ); }
	
	fixed ( fix_t f, bool /*dummy*/ ) : m_f ( f ) { }

	INLINE static fixed biggest() { return((fixed)0x7fffffff); }

	//data
	fix_t m_f;

// friends:		
#if !_GCC_TEMPLATE_BUG_
	friend fixed operator + <> ( int i, const fixed &f );
	friend fixed operator - <> ( int i, const fixed &f );
	friend fixed operator * <> ( int i, const fixed &f );
	friend fixed operator / <> ( int i, const fixed &f );

	friend fixed operator + <> ( double d, const fixed &f );
	friend fixed operator - <> ( double d, const fixed &f );
	friend fixed operator * <> ( double d, const fixed &f );
	friend fixed &operator / <> ( double d, const fixed<SH> &f );

	friend bool operator <  <> ( double d, const fixed &f );
	friend bool operator >  <> ( double d, const fixed &f );
	friend bool operator <= <> ( double d, const fixed &f );
	friend bool operator >= <> ( double d, const fixed &f );
	friend bool operator == <> ( double d, const fixed &f );
	friend bool operator != <> ( double d, const fixed &f );

	friend bool operator <  <> ( int i, const fixed &f );
	friend bool operator >  <> ( int i, const fixed &f );
	friend bool operator <= <> ( int i, const fixed &f );
	friend bool operator >= <> ( int i, const fixed &f );
	friend bool operator == <> ( int i, const fixed &f );
	friend bool operator != <> ( int i, const fixed &f );
	
	friend long int lrint ( const fixed &f );
	friend fixed sqrt ( const fixed &f );
	friend fixed fabs ( const fixed &f );
#endif
};


template <unsigned int SH> INLINE fixed<SH> operator + ( int i, const fixed<SH> &f )  { return fixed<SH> ( fixed<SH>::i2f( i ) + f. m_f, true ); }
template <unsigned int SH> INLINE fixed<SH> operator - ( int i, const fixed<SH> &f )  { return fixed<SH> ( fixed<SH>::i2f( i ) - f. m_f, true ); }
template <unsigned int SH> INLINE fixed<SH> operator * ( int i, const fixed<SH> &f )  { 
  TEST4(fixed<SH>::f2d(f.m_f)*i,f.m_f*i,"i*",
	printf("%f * %d = %f\n", fixed<SH>::f2d(f.m_f), i, fixed<SH>::f2d(f.m_f*i)));
  return fixed<SH> ( i * f. m_f, true ); 
}

template <unsigned int SH> INLINE fixed<SH> operator / ( int i, const fixed<SH> &f )  { 
  TEST4(fixed<SH>::f2d(f.m_f)/i,f.m_f/i,"i/",
	printf("%f / %d = %f\n", fixed<SH>::f2d(f.m_f), i, fixed<SH>::f2d(f.m_f/i)));
  
  return fixed<SH> ( fixed<SH>::div ( f.m_f, fixed<SH>::i2f( i ) ), true ); 
} 

//template <unsigned int SH> INLINE fixed<SH> operator / ( int i, const fixed<SH> &f )  { return fixed<SH> ( fixed<SH>::i2f ( i / fixed<SH>::f2i ( f. m_f )), true ); } 

template <unsigned int SH> INLINE fixed<SH> operator + ( double d, const fixed<SH> &f ) { return fixed<SH> ( fixed<SH>::d2f( d ) + f. m_f, true ); }
template <unsigned int SH> INLINE fixed<SH> operator - ( double d, const fixed<SH> &f ) { return fixed<SH> ( fixed<SH>::d2f( d ) - f. m_f, true ); }
template <unsigned int SH> INLINE fixed<SH> operator * ( double d, const fixed<SH> &f ) { 
  TEST4(fixed<SH>::f2d(f.m_f)*d,fixed<SH>::mul(f.m_f,fixed<SH>::d2f(d)),"d*",
	printf("%f * %f = %f\n", fixed<SH>::f2d(f.m_f), d, fixed<SH>::f2d(fixed<SH>::mul(f.m_f,fixed<SH>::d2f(d)))));
  return fixed<SH> ( fixed<SH>::mul ( fixed<SH>::d2f( d ), f. m_f ), true ); 
}
template <unsigned int SH> INLINE fixed<SH> operator / ( double d, const fixed<SH> &f ) { 
  TEST4((fixed<SH>::f2d(f.m_f))/d,fixed<SH>::div(fixed<SH>::d2f(d),f.m_f),"d/",
	printf("%f / %f = %f\n", fixed<SH>::f2d(f.m_f), d, fixed<SH>::f2d(fixed<SH>::div(f.m_f,fixed<SH>::d2f(d)))));
  return fixed<SH> ( fixed<SH>::div ( fixed<SH>::d2f( d ), f. m_f ), true ); 
}

template <unsigned int SH> INLINE bool operator <  ( double d, const fixed<SH> &f ) { return fixed<SH>::d2f( d ) < f. m_f; }
template <unsigned int SH> INLINE bool operator >  ( double d, const fixed<SH> &f ) { return fixed<SH>::d2f( d ) > f. m_f; }
template <unsigned int SH> INLINE bool operator <= ( double d, const fixed<SH> &f ) { return fixed<SH>::d2f( d ) <= f. m_f; }
template <unsigned int SH> INLINE bool operator >= ( double d, const fixed<SH> &f ) { return fixed<SH>::d2f( d ) >= f. m_f; }
template <unsigned int SH> INLINE bool operator == ( double d, const fixed<SH> &f ) { return fixed<SH>::d2f( d ) == f. m_f; }
template <unsigned int SH> INLINE bool operator != ( double d, const fixed<SH> &f ) { return fixed<SH>::d2f( d ) != f. m_f; }

template <unsigned int SH> INLINE bool operator <  ( int i, const fixed<SH> &f ) { return fixed<SH>::i2f( i ) < f. m_f; }
template <unsigned int SH> INLINE bool operator >  ( int i, const fixed<SH> &f ) { return fixed<SH>::i2f( i ) > f. m_f; }
template <unsigned int SH> INLINE bool operator <= ( int i, const fixed<SH> &f ) { return fixed<SH>::i2f( i ) <= f. m_f; }
template <unsigned int SH> INLINE bool operator >= ( int i, const fixed<SH> &f ) { return fixed<SH>::i2f( i ) >= f. m_f; }
template <unsigned int SH> INLINE bool operator == ( int i, const fixed<SH> &f ) { return fixed<SH>::i2f( i ) == f. m_f; }
template <unsigned int SH> INLINE bool operator != ( int i, const fixed<SH> &f ) { return fixed<SH>::i2f( i ) != f. m_f; }

template <unsigned int SH> INLINE long int lrint ( const fixed<SH> &f )
{
  return fixed<SH>::f2i (( f. m_f < 0 ) ? f. m_f - ( 1 << ( SH - 1 )) : f. m_f + ( 1 << ( SH - 1 )));
}

template <unsigned int SH> INLINE fixed<SH> fabs ( const fixed<SH> &f )
{
	return ( f. m_f < 0 ) ? fixed<SH> ( -f. m_f, true ) : f;
}

// roughly from QPE / qmath.h 
template <unsigned int SH> INLINE fixed<SH> sqrt ( const fixed<SH> &f )
{
	if ( f. m_f <= 0 )
		return fixed<SH> ( 0, true );
		
	typename fixed<SH>::fix_t a0 = 0;
	typename fixed<SH>::fix_t a1 = f. m_f; // take value as first approximation
	
	int loops = 1000;
	do {
		a0 = a1;
		a1 = ( a0 + fixed<SH>::div ( f. m_f, a0 )) >> 1;
		if (loops-- == 0) {
		  break;
		}
	} while ( abs ( fixed<SH>::div ( a1 - a0,  a1 )) > 1 );
	if (loops == 0) {
	  printf("sqrt error, f = %f (%x)  a0=%d a1=%d\n",
		 (float)f, f.m_f, a0, a1);
	}
	return fixed<SH> ( a1, true );
}

template <unsigned int SH> INLINE unsigned char getpix ( const fixed<SH> &f )
{
  // map [0.0,1.0] into [0,255] quickly, makes a little compromise: 1/255 is 0
  // also, does not check if > 1.0 will do the wrong thing, but so did the original code
  return (0xff & (f.m_f > 1? ((f.m_f - 1) >> (SH - 8)) : 0));
}


#if 0 // no std::ostream needed in OPIE
template <unsigned int SH> INLINE std::ostream &operator << ( std::ostream &o, const fixed<SH> &f )
{
	o << double( f );
	return o;
}
#endif

#endif
