#ifndef __QDOCSTATE_H
#define __QDOCSTATE_H


typedef enum { PDF_VIEW = 1, TEXT_VIEW, NOTES_VIEW, PDF_DOC_BROWSER, PDF_DIR_BROWSER, PREFERENCES_PAGE, HELP_VIEW } ViewMode;

class QDocState  {
public:
  QDocState();
  void clear();
  void home();
  void pos(int x, int y);
  void pos(QPoint p) { pos(p.x(),p.y()); }

  void save(QString &str);
  int load(const QString &str, int index = 0, bool loadPath = false);
  void set(QDocState &);
  
  QString filename();
  QString basename();
  bool isSamePixmap(QDocState &);
  bool isSamePage(QDocState &);

  bool doMove;

  bool isValid() { 
    //    if (!(page > 0 && numPages > 0 && !path.isEmpty() && width > 0 && height > 0)) {
    if (path.isEmpty() || numPages <= 0) {
      printf("state not valid:\n");
      dump();
    }
    //    return(page > 0 && numPages > 0 && !path.isEmpty() && width > 0 && height > 0); 
    return(!(path.isEmpty() || numPages <= 0));
  }

  void dump() {
    printf("state x=%d y=%d move=%d rot=%d zoom=%f page=%d/%d path=%s width=%d height=%d\n",
	   x,y,doMove, isRotated, zoom, page, numPages, path.latin1(), width, height);
  }

  // issue: this is currently changed by rotation code
  int x, y;  // upper left corner

  bool isRotated;
  float zoom;
  QString path;
  int page;
  int numPages;

  int page_offset;
  bool reproportion_text;
  bool reproportion_and_render;
  bool render_text;
  bool auto_sense_render_text;

  ViewMode mode;

  int width, height;
  int char_index;
};
#endif
