#include <qstring.h>
#include <qstringlist.h>
#include <qpoint.h>
#include <stdio.h>

#include "qdocstate.h"

#include "preferences.h"

class QPDFconfig : public qpdf_configuration {
  Q_OBJECT
 public:
  QPDFconfig(QWidget *parent);
  void run();

  bool startup_document_browser;
  bool startup_directory_browser;
  bool startup_last_viewed_document;

  bool open_notes_view;
  bool open_last_viewed_page;

  bool default_render_text;
  bool default_adjust_spacing;
  float default_zoom;
  QString default_font_name;
  int default_font_size;

  QDocState last_state;

  QStringList category_list;
  QStringList recent_dirs;
  QStringList recent_files;

  int max_recent_files;
  int max_recent_dirs;

  void read();
  void write(QDocState &s);

  bool c7xx;

  bool clean;
  
 private slots:
   void okaySlot();
   void cancelSlot();

};
