#include "aconf.h"

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <iostream>
#include <assert.h>


#include <qgfx_qws.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qpainter.h>
#include <qdict.h>
#include <qtimer.h>
#include <qlabel.h>
#include <qscrollview.h>
#include <qmessagebox.h>
#include <qapplication.h>

#include "qdocview.h"

#include "GString.h"
#include "PDFDoc.h"
#include "TextOutputDev.h"

#include "QOutputDev.h"

  
// there are memory issues with zooms over 1.8 on the SL-5500
#ifdef AUTOTEST
const float MAX_ZOOM = 2.0;
const float MIN_ZOOM = 0.05;
#else
const float MAX_ZOOM = 3.0;
const float MIN_ZOOM = 0.1;
#endif

class QPDFView : public QDocView
{
  Q_OBJECT

 public:
  QPDFView(QWidget *parent, const char *name, int flags, QPDFconfig *config);
  virtual ~QPDFView();

  virtual bool switchDocument(QDocState* target);
  virtual void switchPage(QDocState target);
  virtual bool readPage(QDocState target, QPixmap **pixmap_ptr);
  virtual bool readTextPage(QDocState target, QDocText **textmap_ptr);
  virtual void abortReadPage();
  virtual void limitState(QDocState &state);
  virtual bool foundRenderedText() { return(m_outdev->m_found_render_font); }


  bool isOk();

 signals:
  void newDocument(int);

 protected:
  //  QString wrapText(QString text);

 private:
  void closeDocument();
  bool openDocument(QDocState *target = NULL);
  PDFDoc *m_pdfdoc;
  QOutputDev *m_outdev;
};
