/****************************************************************************
** $Id: qt/src/kernel/qimage.h   2.3.8-snapshot-20040114   edited 2002-07-31 $
**
** Definition of QQImage and QQImageIO classes
**
** Created : 950207
**
** Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
**
** This file is part of the kernel module of the Qt GUI Toolkit.
**
** This file may be distributed under the terms of the Q Public License
** as defined by Trolltech AS of Norway and appearing in the file
** LICENSE.QPL included in the packaging of this file.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** Licensees holding valid Qt Enterprise Edition or Qt Professional Edition
** licenses may use this file in accordance with the Qt Commercial License
** Agreement provided with the Software.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
**   information about Qt Commercial License Agreements.
** See http://www.trolltech.com/qpl/ for QPL licensing information.
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

#ifndef QQIMAGE_H
#define QQIMAGE_H

#ifndef QT_H
#include "qpixmap.h"
#include "qstrlist.h"
#include "qstringlist.h"
#endif // QT_H


class Q_EXPORT QQImage : public QImage
{
public:
    QQImage();
    QQImage( int width, int height, int depth, int numColors=0,
	    Endian bitOrder=IgnoreEndian );

    QQImage( const QQImage & );
    QQImage( const QImage & );

    QQImage     &operator=( const QQImage & );

#ifndef QT_NO_IMAGE_SMOOTHSCALE
    QQImage	smoothScale(int width, int height) const;
#endif
};


class QImageSmoothScalerPrivate;
class QImageSmoothScaler
{
public:
    QImageSmoothScaler(const int w, const int h, const QImage &src);
    QImageSmoothScaler(const int srcWidth, const int srcHeight,
	const char *parameters);

    virtual ~QImageSmoothScaler(void);

    QImage  scale();

protected:
    int scaledWidth(void) const;

private:
    QImageSmoothScalerPrivate	*d;
    virtual QRgb* scanLine(const int line = 0, const QImage *src = 0);
};

class QQImageSmoothScalerPrivate;
class QQImageSmoothScaler
{
public:
    QQImageSmoothScaler(const int w, const int h, const QQImage &src);
    QQImageSmoothScaler(const int srcWidth, const int srcHeight,
	const char *parameters);

    virtual ~QQImageSmoothScaler(void);

    QQImage  scale();

protected:
    int scaledWidth(void) const;

private:
    QQImageSmoothScalerPrivate	*d;
    virtual QRgb* scanLine(const int line = 0, const QQImage *src = 0);
};

#endif // QQIMAGE_H
