
class QDocBase {
 public:

  QDocBase();
  ~QDocBase();
  bool getPixmap(QString path, int page, fouble zoom, QPixmap **pixmap_ptr, QDocTextmap **textmap_ptr);
  bool getTextmap(QString path, int page, QDocTextmap **textmap_ptr);
  void abort();

  bool busy() { return(m_busy); }
  QString path() { return(m_path); }
  int page() { return(m_page); }
  int numPages() { return(m_numPages); }
  fouble zoom() { return(m_zoom); }
  int textmapPage() { return(m_textmapPage); }

  QString getText(int page, int from_word = 0, int to_word = -1, int page = -1);
  QRegion getTextRegion(int page, int from_word = 0, int to_word = -1);

  int mapPixToWord(int page, QPoint pix, bool closest = true); // return -1 if textmap not valid
  QPoint mapWordToPix(int page, int wordIndex, bool lastChar = false);
  int mapWordToChar(int page, int wordIndex, bool lastChar = false);
  int mapCharToWord(int page, int charIndex);
  int mapPixToChar(int page, QPoint pix, bool closest = true); // return -1 if textmap not valid
  QPoint mapCharToPix(int page, int charIndex, bool lastChar = false);

  bool findText(const QString &string, int *page, int *from_char, int *to_char,
		bool reverse, bool multipage);

  bool findTextInternal(QString text, 
			int first_page = 0, int last_page = -1,
			int *from_char, int *to_char, 
			int *page = NULL);


 protected signals:
    void gotPage();

 private:

  virtual bool getPage(QString path, int page, float zoom, QPixmap **pixmap_ptr, QDocTextmap *textmap_ptr, int *numPages);
  virtual void abortGetPage();

  int m_page;
  int m_num_pages;
  int m_aux_textmap_page;
  fouble m_zoom;
  QString m_path;
  bool m_busy;

  QPixmap **m_pixmap_ptr;
  QDocTextmap *m_pixmap_textmap;
  QDocTextmap *m_aux_textmap;
};

