/**********************************************************************
** Copyright (C) 2000-2002 Trolltech AS.  All rights reserved.
**
** This file is part of the Qtopia Environment.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

#ifndef TEXTEDIT_H
#define TEXTEDIT_H

#define QTEXTEDIT_OPEN_API

#include <qpe/filemanager.h>

#include <qmainwindow.h>
#include <qmultilineedit.h>
#include <qlist.h>
#include <qmap.h>
#include <qevent.h>

class QWidgetStack;
class QToolButton;
class QPopupMenu;
class QToolBar;
class QLineEdit;
class QAction;
class FileSelector;
class QpeEditor;



class QDocText : public QDocState, public QTextEdit
{
    Q_OBJECT

public:
    QDocText( QWidget *parent = 0, const char *name = 0, WFlags f = 0);
    ~QDocText();

    virtual void clear();
    virtual void changeState();
    virtual void abortChangeState();
    virtual void open();
    virtual void close();

public slots:

signals:

protected:


private:
    bool m_mouse_inside_selection;
    QPoint m_mouse_start;

    QDocBase *m_doc;
    QDocTextmap *m_textmap;
};

#endif
