#ifndef _QDOCTEXT_H
#define _QDOCTEXT_H

#include "aconf.h"

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <iostream>
#include <assert.h>

#include <qgfx_qws.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qpainter.h>
#include <qdict.h>
#include <qtimer.h>
#include <qlabel.h>
#include <qscrollview.h>
#include <qmessagebox.h>
#include <qapplication.h>


class QDocTextmapWord {
 public:
  QDocTextmapWord(QRect box, int firstChar, int lastChar);
  ~QDocTextmapWord() {}
  bool contains(QPoint);
  bool contains(int charIndex);

  int firstCharIndex, lastCharIndex;
  QRect box;
};

class QDocTextmap {
 public:
  QDocTextmap();
  virtual ~QDocTextmap();

  bool deref();
  void ref();

  void clear();

  int numWords();
  int numChars();
  int findWord(QPoint point, bool closest = true);
  int findWord(QDocState state, bool closest = true);
  int findWord(QString string);
  bool findString(const QString &str, int *firstChar, int *lastChar);

  QString getText(int firstWord = 0, int lastWord = -1);

  bool isTextMapValid(QDocState &state) { return(isSamePixmap(state)); }
  bool isTextValid(QDocState &state) { return(isSamePage(state)); }

  bool isSamePage(QDocState &state) {
    return(m_state.isSamePage(state));
  }
  bool isSamePixmap(QDocState &state) {
    return(m_state.isSamePixmap(state));
  }
  void setState(QDocState *state) { m_state = *state; }
  void setText(QString str);
  
  int mapWordToChar(int wordNum, int *firstCharIndex = NULL, int *lastCharIndex = NULL);
  int mapCharToWord(int charNum);
  QRect wordBox(int word);
  QRegion wordRegion(int firstWord, int lastWord);
  //  QString wordString(int firstWord, int lastWord);

  QDocState m_state;

  void addWord(int x1, int y1, int x2, int y2, int first_char, int last_char);

 private:
  QString m_text;
  QList<QDocTextmapWord> m_words;
  int m_refcount;
};
#endif
