
#include "aconf.h"

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <iostream>
#include <assert.h>

#include <qgfx_qws.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qpainter.h>
#include <qdict.h>
#include <qtimer.h>
#include <qlabel.h>
#include <qscrollview.h>
#include <qmessagebox.h>
#include <qapplication.h>


enum { CORNER_NONE, 
       CORNER_UPPER_LEFT, CORNER_UPPER_RIGHT,
       CORNER_LOWER_LEFT, CORNER_LOWER_RIGHT };

enum { EDGE_NONE, 
       EDGE_TOP, EDGE_BOTTOM, EDGE_LEFT, EDGE_RIGHT };

class QGestureScrollView : public QScrollView  {
  Q_OBJECT

public:
  QGesture(QWidget *parent, const char *name, int flags) ;
  
  bool doingGesture();
  void gestureAbort();
  void gestureStart();

protected:
  // hooks for gesture actions
  virtual void gestureCircle() {};
  virtual void gestureDiagonal() {};
  virtual void gestureHorizontal() {};
  virtual void gestureVertical() {};
  virtual void gestureTouch() {};
  virtual void gestureCheck() {};

  bool gestureMouseMove(QMouseEvent *);
  bool gestureMousePress(QMouseEvent *);
  bool gestureMouseRelease(QMouseEvent *);
  
  int detectEdges(QPoint pos);
  int detectCorners(QPoint pos);

  QPoint m_gesture_start;
  QPoint m_gesture_end;
  QRect m_gesture_box;
  QPoint m_gesture_delta;
  int m_gesture_length;

 private:
  void gestureEnd();

  bool m_doing_gesture;
  bool m_gesture_started;
  QTimer *m_gesture_timer;

private slots:
  void gestureTimerEvent();
};


