//========================================================================
//
// SFont.cc
//
// Copyright 2001-2002 Glyph & Cog, LLC
//
//========================================================================

#include <aconf.h>

#ifdef USE_GCC_PRAGMAS
#pragma implementation
#endif

#include <stdio.h>
#include "SFont.h"

//------------------------------------------------------------------------

SFontEngine::SFontEngine() {
}

SFontEngine::~SFontEngine() {
}

void SFontEngine::useTrueColor(int rMaxA, int rShiftA, int gMaxA, int gShiftA,
			       int bMaxA, int bShiftA) {
  trueColor = gTrue;
  bpp = QPixmap::defaultDepth()/8;
  rMax = rMaxA;
  rShift = rShiftA;
  gMax = gMaxA;
  gShift = gShiftA;
  bMax = bMaxA;
  bShift = bShiftA;
}

void SFontEngine::useColorCube(Gulong *colorsA, int nRGBA) {
  trueColor = gFalse;
  colors = colorsA;
  nRGB = nRGBA;
  rMax = gMax = bMax = nRGB - 1;
}

Gulong SFontEngine::findColor(int r1, int g1, int b1) {
  Gulong pix;

  // at this point, it seems r1 g1 b1 are from 0 to 0xffff

  if (bpp == 2) {
    // 565
    // could do some rounding here to get fancy...
    pix = (b1>>11) + ((g1>>10) << 5) + (r1 & 0xf800);
    //    pix = (r1>>3) + ((g1>>2) << 5) + ((b1>>3) << 11);
  } else {
    pix = (b1>>8) + (g1 & 0xff00) + ((r1 & 0xff00) << 8);
    //    pix = (r1>>8) + (g1 << 8) + (b1 << 16);
  }

  //  r1 = ((r & 0xffff) * rMax) / 0xffff;
  //  g1 = ((g & 0xffff) * gMax) / 0xffff;
  //  b1 = ((b & 0xffff) * bMax) / 0xffff;
  //  if (trueColor) {
  //    pix = (r1 << rShift) + (g1 << gShift) + (b1 << bShift);
  //  } else {
  //    pix = colors[(r1 * nRGB + g1) * nRGB + b1];
  //  }
  return pix;
}

//------------------------------------------------------------------------

SFontFile::SFontFile() {
}

SFontFile::~SFontFile() {
}

//------------------------------------------------------------------------

SFont::SFont() {
}

SFont::~SFont() {
}

GBool SFont::getCharPath(CharCode c, Unicode u, GfxState *state) {
  return gFalse;
}
